﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	
	public class Fourmizer extends Sprite
	{
		private var quantity:Number = 50;
		private var dotNum:Number = 0
		private var dots:Array = [];
		private var vitesseMax:Number = 0.4;
		public function Fourmizer()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			for(var i:Number = 0;i<quantity;i++){
				addDot(Math.random()*stage.stageWidth,Math.random()*stage.stageHeight);
			}
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		
		private function addDot(x:Number,y:Number):void
		{
			dots[dotNum] = new Object();
			dots[dotNum].x = x;
			dots[dotNum].y = y;
			dots[dotNum].angle = Math.random()*2*Math.PI;
			dots[dotNum].v = Math.random()*vitesseMax;
			dots[dotNum].s = new Sprite();
			
			dots[dotNum].s.graphics.beginFill(0x696969, 0.1);
			dots[dotNum].s.graphics.drawCircle(50, 50, 50);
			dots[dotNum].s.graphics.endFill();
				dots[dotNum].s.graphics.beginFill(0x540400,Math.random()*0.5);
			    dots[dotNum].s.graphics.lineStyle(1*Math.random()/2, 0x000000, Math.random()*0.8);
				dots[dotNum].s.graphics.moveTo(0, 0);
				dots[dotNum].s.graphics.curveTo(10, 0, 20, 20);
				dots[dotNum].s.graphics.curveTo(10, 20, 0, 20);
				dots[dotNum].s.graphics.endFill();
				dots[dotNum].s.graphics.lineStyle(1, 0xffffff, 0.2);
				dots[dotNum].s.graphics.lineTo(50,10);
				
 				
			addChild(dots[dotNum].s);
			dotNum++;
		}
		
		private function enterHandler(e:Event):void
		{
			movedot();
		}
		
		private function movedot():void
		{
			var i:Number,t:Number;
			var a:Number,s:Number,x:Number,y:Number,cx:Number,cy:Number,vx:Number,vy:Number;
			
			for(i = 0;i<dotNum;i++){
				x = dots[i].x;
				y = dots[i].y;
				a = dots[i].angle*(mouseX*mouseY);
				s = dots[i].v;
				vx = Math.cos(a)*s;
				vy = Math.sin(a)*s;
				x+=vx;
				y+=vy;
				if(x<3 || x>=stage.stageWidth-3 || y<3 ||y>=stage.stageHeight-30){
					if(x<3){
						x = 3
						vx*=-1;
					}
					if(x>stage.stageWidth-2){
						x = stage.stageWidth-2 ;
						vx*=-1;
					}
					if(y<3){
						y = 3;
						vy*=-10;
					}
					if(y>stage.stageHeight-2){
						y = stage.stageHeight-200;
						vy*=-1;
					}
					dots[i].angle = Math.atan2(vy,vx);
				}
				//position
				dots[i].s.x = dots[i].x = x;
				dots[i].s.y = dots[i].y = y;
				if(Math.random()<.1){
					dots[i].angle+=Math.random()-.1;
				}
				if(Math.random()<.1){
					dots[i].v+=Math.random()-.5;
					dots[i].v = Math.max(0,Math.min(vitesseMax,Math.abs(dots[i].v)));
				}
			}
			
		}
	}
}